Bug 223123 - lang/rust: update to 1.21
Summary: lang/rust: update to 1.21
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Only Me
Assignee: Jean-Sébastien Pédron
URL:
Keywords: needs-patch
Depends on:
Blocks:
 
Reported: 2017-10-20 06:10 UTC by Jan Beich
Modified: 2017-10-28 09:16 UTC (History)
3 users (show)

See Also:
dumbbell: maintainer-feedback+
jbeich: maintainer-feedback? (riggs)


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Jan Beich freebsd_committer 2017-10-20 06:10:29 UTC
Firefox 58 (scheduled on 2018-01-16) will require Rust 1.21 to build. To avoid MFH pain the port needs to be updated before 2018Q1 is branched.
Comment 1 Bugzilla Automation freebsd_committer 2017-10-20 06:10:29 UTC
Maintainer informed via mail
Comment 2 Jan Beich freebsd_committer 2017-10-20 06:24:00 UTC
The update is also required by mozilla-central buildbot[1]. It runs on -CURRENT, so rustup binaries are unusable until ino64, etc. ABI issues are resolved.

[1] http://buildbot.rhaalovely.net/builders/mozilla-central-freebsd-amd64/
Comment 3 Jean-Sébastien Pédron freebsd_committer 2017-10-20 07:35:33 UTC
Hi!

I have a local patch to update lang/rust to 1.21.0. The aarch64 bootstrap is also ready (but will be affected by the linker problem you reported).

Unfortunately, the build hangs forever when compiling one of the crate (100% reproducible, also outside of Poudriere). I didn't have a chance to even do a search to see if the problem exists elsewhere :-/
Comment 4 Jan Beich freebsd_committer 2017-10-20 07:57:01 UTC
Can't you regen i686/x86_64 bootstrap based on 10.3 package for Rust 1.20, similar to aarch64? For one, DragonFly used to do something similar.

https://github.com/DragonFlyBSD/DeltaPorts/blob/ad5e910c9585/ports/lang/rust/Makefile.DragonFly
Comment 5 Jan Beich freebsd_committer 2017-10-22 07:55:39 UTC
FWIW, all consumers built fine with Rust 1.21 on 10.3 i386 and 11.1 amd64.
Comment 6 Jean-Sébastien Pédron freebsd_committer 2017-10-23 08:42:59 UTC
I will try that, thanks!
Comment 7 Jean-Sébastien Pédron freebsd_committer 2017-10-23 22:23:21 UTC
After recreating the amd64 bootstraps from the FreeBSD 10.x package, I could build Rust 1.21.0.

I will commit the patch tomorrow, after more tests in Poudriere.
Comment 8 Jan Beich freebsd_committer 2017-10-27 10:55:43 UTC
Ping. mozilla-central as of today requires Rust 1.21.0. Also, the next package build will probably start tonight at 01:00 UTC.
Comment 9 Jean-Sébastien Pédron freebsd_committer 2017-10-27 14:18:46 UTC
I'm currently finishing the testing of the package. It took more time than expected to prepare working bootstraps.

I hope to commit the patch in a couple hours.
Comment 10 commit-hook freebsd_committer 2017-10-28 09:14:14 UTC
A commit references this bug:

Author: dumbbell
Date: Sat Oct 28 09:13:21 UTC 2017
New revision: 453052
URL: https://svnweb.freebsd.org/changeset/ports/453052

Log:
  lang/rust: Update to 1.21.0

  The official bootstraps wouldn't work: rustc was stalled on a mutex
  while compiling a crate early in the build. This was solved by creating
  a new bootstraps for "rustc" and "rust-std" from the existing FreeBSD
  package. We keep using the official "cargo" bootstrap.

  PR:		223123

Changes:
  head/lang/rust/Makefile
  head/lang/rust/distinfo
Comment 11 Jean-Sébastien Pédron freebsd_committer 2017-10-28 09:16:14 UTC
I needed to change one last thing I forgot on HEAD. Now, it builds fine on 10.3, 11.0 and HEAD (Firefox too).